// ==UserScript==
// @name Flash blocker
// @author Lex1
// @version 1.6.9
// @description Unblocks Flash and loads flashblocker images in "Cached images" mode. Works together with FlashBlocker.css.
// @ujs:documentation http://ruzanow.ru/index/0-5
// @ujs:download http://ruzanow.ru/userjs/FlashBlocker.js
// ==/UserScript==


(function(){
	var unblock = function(s){s.content = 'normal'; s.outline = 'none'; s.backgroundImage = 'none'; s.minWidth = 0; s.minHeight = 0};
	var isBlocked = function(ele){
		var tag = (ele && ele.tagName) ? ele.tagName.toLowerCase() : '';
		return (tag == 'embed' || tag == 'object' || tag == 'iframe') && (ele.currentStyle.content || getComputedStyle(ele, null).content) == '""';
	};
	var getSrc = function(ele){
		var src = ele.getAttribute('src') || ele.getAttribute('source') || ele.getAttribute('data');
		if(!src){
			var params = ele.getElementsByTagName('param');
			for(var i = 0, p; p = params[i]; i++){
				if(p.hasAttribute('name') && p.getAttribute('name').match(/^(movie|data|src|code|filename|url|source)$/i)){
					src = p.getAttribute('value'); break;
				}
			}
		}
		return src;
	};

	document.addEventListener('click', function(e){
		var et = e.target;
		if(isBlocked(et)){
			e.preventDefault(); unblock(et.style); var em = et.getElementsByTagName('embed')[0]; if(isBlocked(em))unblock(em.style);
		}
	}, true)

	document.addEventListener('mouseover', function(e){
		var et = e.target;
		if(!et.title && isBlocked(et)){
			var src = getSrc(et); if(src){var a = document.createElement('a'); a.href = src; et.setAttribute('title', a.href)}
		}
	}, false)
})();


/*
document.addEventListener('load', function(){
	var embed = document.getElementsByTagName('embed');
	var obj = document.getElementsByTagName('object');
	var isShowImagesMode = function(){
		var imgs = document.images;
		var l = imgs && imgs.length;
		return l && imgs[0].complete && imgs[l-1].complete;
	};
	if((embed.length == 0 && obj.length == 0) || isShowImagesMode())return;

	var reloadImage = function(s){
		var f = document.createElement('iframe');
		f.src = s;
		f.width = 0;
		f.height = 0;
		f.frameBorder = 'no';
		f.scrolling = 'no';
		f.onload = function(){
			this.parentNode.removeChild(this);
		};
		document.documentElement.appendChild(f);
	};
	var reloadBackImg = function(e){
		for(var i = 0, ele; ele = e[i]; i++){
			var img = ele.currentStyle.backgroundImage || getComputedStyle(ele, null).backgroundImage;
			if(img.indexOf('url("data:image/png;base64,') == 0){
				reloadImage(img.replace(/^url\(\x22|\x22\)$/gi, ''));
				return true;
			}
		}
	};

	if(!reloadBackImg(embed))reloadBackImg(obj);
}, false)
*/
