// ==UserScript==
// @name Flash Block
// @author Lex1
// @version 1.3.8
// @description Blocks Flash and shows placeholder instead. Press Ctrl+Shift+F or Ctrl+Alt+F for permanent unblocking on the site.
// @ujs:documentation http://ruzanow.ru/index/0-5
// @ujs:download http://ruzanow.ru/userjs/FlashBlock-text-button.js
// @exclude http://mail.google.com/*
// @exclude http://files.mail.ru/*
// @exclude http://*megaupload.com/*
// @exclude http://*blizzard.com/*
// @exclude http://example.com/*
// ==/UserScript==

(function(){
	var css = 'object[classid$=":D27CDB6E-AE6D-11cf-96B8-444553540000"],object[codebase*="swflash.cab"],object[data*=".swf"],embed[type="application/x-shockwave-flash"],embed[src*=".swf"],object[type="application/x-shockwave-flash"],object[src*=".swf"],object[codetype="application/x-shockwave-flash"],iframe[type="application/x-shockwave-flash"],iframe[src*=".swf"]';
	css += '{content: "Flash"; outline:1px dotted gray; color:gray;}';
	css += 'object[classid$=":166B1BCA-3F9C-11CF-8075-444553540000"],object[codebase*="sw.cab"],object[data*=".dcr"],embed[type="application/x-director"],embed[src*=".dcr"],object[type="application/x-director"],object[src*=".dcr"]';
	css += '{content: "Director"; outline:1px dotted gray; color:gray;}';
	css += 'object[classid$=":15B782AF-55D8-11D1-B477-006097098764"],object[codebase*="awswaxf.cab"],object[data*=".aam"],embed[type="application/x-authorware-map"],embed[src*=".aam"],object[type="application/x-authorware-map"],object[src*=".aam"]';
	css += '{content: "Authorware"; outline:1px dotted gray; color:gray;}';
	css += 'object[classid*="32C73088-76AE-40F7-AC40-81F62CB2C1DA"],object[type="application/ag-plugin"],object[type="application/x-silverlight"],object[type="application/x-silverlight-2"],object[source*=".xaml"],object[sourceelement*="xaml"],embed[type="application/ag-plugin"],embed[source*=".xaml"]';
	css += '{content: "Silverlight"; outline:1px dotted gray; color:gray;}';
	css += 'object[classid$=":D27CDB6E-AE6D-11cf-96B8-444553540000"]:hover,object[codebase*="swflash.cab"]:hover,object[data*=".swf"]:hover,embed[type="application/x-shockwave-flash"]:hover,embed[src*=".swf"]:hover,object[type="application/x-shockwave-flash"]:hover,object[src*=".swf"]:hover,object[codetype="application/x-shockwave-flash"]:hover,iframe[type="application/x-shockwave-flash"]:hover,iframe[src*=".swf"]:hover,object[classid$=":166B1BCA-3F9C-11CF-8075-444553540000"]:hover,object[codebase*="sw.cab"]:hover,object[data*=".dcr"]:hover,embed[type="application/x-director"]:hover,embed[src*=".dcr"]:hover,object[type="application/x-director"]:hover,object[src*=".dcr"]:hover,object[classid$=":15B782AF-55D8-11D1-B477-006097098764"]:hover,object[codebase*="awswaxf.cab"]:hover,object[data*=".aam"]:hover,embed[type="application/x-authorware-map"]:hover,embed[src*=".aam"]:hover,object[type="application/x-authorware-map"]:hover,object[src*=".aam"]:hover,object[classid*="32C73088-76AE-40F7-AC40-81F62CB2C1DA"]:hover,object[type="application/ag-plugin"]:hover,object[type="application/x-silverlight"]:hover,object[type="application/x-silverlight-2"]:hover,object[source*=".xaml"]:hover,object[sourceelement*="xaml"]:hover,embed[type="application/ag-plugin"]:hover,embed[source*=".xaml"]:hover';
	css += '{content:attr(src) attr(data) "\\A" attr(width) " x " attr(height); display:inline-block; outline:1px dotted black; font-size:smaller; color:black; background-color:#efefef; text-align:left; min-width:60px; min-height:30px; overflow:hidden;}';
	var prefix = 'ujs_flashblock';

	var addStyle = function(css){
		var s = document.createElement('style');
		s.setAttribute('type', 'text/css');
		s.setAttribute('style', 'display: none !important;');
		s.appendChild(document.createTextNode(css));
		return (document.getElementsByTagName('head')[0] || document.documentElement).appendChild(s);
	};

	var setValue = function(name, value, days){
		var date = new Date();
		date.setTime(date.getTime()+((days || 10*365)*24*60*60*1000));
		var curCookie = name+'='+escape(value)+'; expires='+date.toGMTString()+'; path=/';
		if(document.cookie.split(';').length < 20 && document.cookie.length+curCookie.length < 4000){document.cookie = curCookie}else{alert('Cookies is full!')};
	};

	var isValue = function(){
		return document.cookie.indexOf(prefix+'=unblocked') == -1;
	};

	var getVideo = function(flashvars, src){
		var getLink = function(s){var rez = s.match(/[^\s\x22=&?]+\.[^\s\x22=&?\/]*(flv|mp4)/i); return rez ? rez[0] : ''};
		var getQuery = function(s, q){var rez = s.match(new RegExp('[&?]'+q+'=([^&]+)')); return rez ? rez[1] : ''};
		var getURL = function(f, s){return f.match(/^(\w+:\/\/|\/|$)/) ? f : s.replace(/[#?].*$/, '').replace(/[^\/]*$/, f)};

		var flv = decodeURIComponent(flashvars);
		var q = '', url = location.href;

		if( url.indexOf('youtube.com/watch?') != -1 && (q = getQuery(flv, 'video_id')) )return 'http://www.youtube.com/get_video?video_id='+q+'&t='+getQuery(flv, 't')+'&fmt=18';
		if( url.indexOf('video.google.com/videoplay?') != -1 && (q = getQuery(src, 'videoUrl')) )return decodeURIComponent(q);
		if( url.indexOf('metacafe.com/watch/') != -1 && (q = getQuery(flv, 'mediaURL')) )return q+'?__gda__='+getQuery(flv, 'gdaKey');
		if( url.indexOf('dailymotion.com/') != -1 && (q = getQuery(flv, 'video')) )return q.match(/[^@]+/);

		return getURL(getLink(flv) || decodeURIComponent(getLink(src)), src);
	};

	var getParam = function(e, n){
		var v = '', r = new RegExp('^('+n+')$', 'i');
		var param = e.getElementsByTagName('param');
		for(var i = 0, p; p = param[i]; i++){
			if(p.hasAttribute('name') && p.getAttribute('name').match(r)){v = p.getAttribute('value'); break};
		};
		return v;
	};

	var unblock = function(s){
		s.content = 'normal';
		s.outline = 'none';
		s.fontSize = 'inherit';
		s.color = 'inherit';
		s.backgroundColor = 'inherit';
		s.minWidth = 0;
		s.minHeight = 0;
	};

	var isBlocked = function(ele){
		var tag = (ele && ele.tagName) ? ele.tagName.toLowerCase() : '';
		return (tag == 'embed' || tag == 'object' || tag == 'iframe') && (ele.currentStyle.content || getComputedStyle(ele, null).content).indexOf('attr(src)') == 0;
	};

	var unblockFlash = function(e){
		var et = e.target;
		if(isBlocked(et) && !e.shiftKey && !e.altKey){
			e.preventDefault();
			if(e.ctrlKey){
				// Save video with Ctrl+Click
				var v = getVideo(et.getAttribute('flashvars') || getParam(et, 'flashvars'), et.getAttribute('src') || et.getAttribute('data'));
				if(v)location.href = v;
			}
			else{
				// Unblock flash
				unblock(et.style);
				var em = et.getElementsByTagName('embed')[0];
				if(em)unblock(em.style);
			}
		}
	};

	var showAddress = function(e){
		var et = e.target;
		if(!et.hasAttribute('data') && !et.hasAttribute('src') && isBlocked(et)){
			var src = getParam(et, 'movie|data|src|code|filename|url|source');
			if(src)et.setAttribute('data', src);
		}
	};


	// Blocking
	if(isValue()){
		addStyle(css);
		document.addEventListener('click', unblockFlash, true);
		document.addEventListener('mouseover', showAddress, false);
	};

	// Unblock for the site with Ctrl+Shift+F or Ctrl+Alt+F
	document.addEventListener('keypress', function(e){
		if(e.keyCode == 70 && e.ctrlKey && (e.shiftKey != e.altKey)){
			if(isValue()){
				var styles = document.getElementsByTagName('style');
				for(var i = 0, s; s = styles[i]; i++){
					if(s.innerHTML == css){s.parentNode.removeChild(s); break}
				};
				document.removeEventListener('click', unblockFlash, true);
				document.removeEventListener('mouseover', showAddress, false);
				setValue(prefix, 'unblocked');
			}
			else{
				addStyle(css);
				document.addEventListener('click', unblockFlash, true);
				document.addEventListener('mouseover', showAddress, false);
				setValue(prefix, 'blocked', -1);
			}
		}
	}, false);
})();